@if "%DEBUG%" == "" @echo off
@rem ##########################################################################
@rem
@rem  studio startup script for Windows
@rem
@rem ##########################################################################

@rem Set local scope for the variables with windows NT shell
if "%OS%"=="Windows_NT" setlocal

set DIRNAME=%~dp0
if "%DIRNAME%" == "" set DIRNAME=.
set APP_BASE_NAME=%~n0
set APP_HOME=%DIRNAME%..

@rem Add default JVM options here. You can also use JAVA_OPTS and STUDIO_OPTS to pass JVM options to this script.
set DEFAULT_JVM_OPTS="-Xmx512m" "-Dfile.encoding=UTF-8" "-Dstudio.user.home=%USERPROFILE%\.haulmont\studio"

@rem Find java.exe
if defined JAVA_HOME goto findJavaFromJavaHome

set JAVA_EXE=javaw.exe
%JAVA_EXE% -version >NUL 2>&1
if "%ERRORLEVEL%" == "0" goto init

echo.
echo ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH.
echo.
echo Please set the JAVA_HOME variable in your environment to match the
echo location of your Java installation.

goto fail

:findJavaFromJavaHome
set JAVA_HOME=%JAVA_HOME:"=%
set JAVA_EXE=%JAVA_HOME%/bin/javaw.exe

if exist "%JAVA_EXE%" goto init

echo.
echo ERROR: JAVA_HOME is set to an invalid directory: %JAVA_HOME%
echo.
echo Please set the JAVA_HOME variable in your environment to match the
echo location of your Java installation.

goto fail

:init
@rem Get command-line arguments, handling Windows variants

if not "%OS%" == "Windows_NT" goto win9xME_args

:win9xME_args
@rem Slurp the command line arguments.
set CMD_LINE_ARGS=
set _SKIP=2

:win9xME_args_slurp
if "x%~1" == "x" goto set_vars

set CMD_LINE_ARGS=%*

:set_vars
set STUDIO_HOME=%APP_HOME%
set STUDIO_VERSION=6.5.4
set STUDIO_MINOR_VERSION=6.5
set /A STUDIO_BUGFIX_VERSION=4
if exist %USERPROFILE%\.haulmont\studio\update\%STUDIO_MINOR_VERSION% (goto updated) else (goto execute)

:updated
set UPDATE_BUGFIX_VERSION=00
for /D %%S in (%USERPROFILE%\.haulmont\studio\update\%STUDIO_MINOR_VERSION%\??) do set UPDATE_BUGFIX_VERSION=%%~nxS
set /A SHORT_BUGFIX_VERSION=%UPDATE_BUGFIX_VERSION%
if %SHORT_BUGFIX_VERSION% leq %STUDIO_BUGFIX_VERSION% goto execute
set STUDIO_HOME=%USERPROFILE%\.haulmont\studio\update\%STUDIO_MINOR_VERSION%\%UPDATE_BUGFIX_VERSION%
set STUDIO_VERSION=%STUDIO_MINOR_VERSION%.%SHORT_BUGFIX_VERSION%

:execute
@rem Setup the command line

set CLASSPATH=%STUDIO_HOME%\lib\studio-server-%STUDIO_VERSION%.jar;%STUDIO_HOME%\lib\slf4j-api-1.7.12.jar;%STUDIO_HOME%\lib\slf4j-log4j12-1.7.12.jar;%STUDIO_HOME%\lib\jul-to-slf4j-1.7.12.jar;%STUDIO_HOME%\lib\log4j-1.2.17.jar;%STUDIO_HOME%\lib\jsr305-3.0.0.jar;%STUDIO_HOME%\lib\practicalxml-1.1.11.jar;%STUDIO_HOME%\lib\guava-18.0.jar;%STUDIO_HOME%\lib\commons-lang-2.6.jar;%STUDIO_HOME%\lib\commons-io-2.4.jar;%STUDIO_HOME%\lib\json-20140107.jar;%STUDIO_HOME%\lib\jelastic-public-j2se-5.0.6.jar;%STUDIO_HOME%\lib\studio-ui-%STUDIO_VERSION%.jar;%STUDIO_HOME%\lib\jetty-server-9.2.20.v20161216.jar;%STUDIO_HOME%\lib\jetty-servlet-9.2.20.v20161216.jar;%STUDIO_HOME%\lib\jetty-webapp-9.2.20.v20161216.jar;%STUDIO_HOME%\lib\websocket-server-9.2.20.v20161216.jar;%STUDIO_HOME%\lib\gson-2.4.jar;%STUDIO_HOME%\lib\studio-backend-%STUDIO_VERSION%.jar;%STUDIO_HOME%\lib\vaadin-server-7.7.7.cuba.0.jar;%STUDIO_HOME%\lib\vaadin-push-7.7.7.cuba.0.jar;%STUDIO_HOME%\lib\aceeditor-0.8.14.jar;%STUDIO_HOME%\lib\popupbutton-2.6.0.jar;%STUDIO_HOME%\lib\dragdroplayouts-1.3.2.cuba.3.jar;%STUDIO_HOME%\lib\vaadin-context-menu-0.7.5.jar;%STUDIO_HOME%\lib\antlr-runtime-3.2.jar;%STUDIO_HOME%\lib\javax.servlet-api-3.1.0.jar;%STUDIO_HOME%\lib\jetty-http-9.2.20.v20161216.jar;%STUDIO_HOME%\lib\jetty-io-9.2.20.v20161216.jar;%STUDIO_HOME%\lib\jetty-security-9.2.20.v20161216.jar;%STUDIO_HOME%\lib\jetty-xml-9.2.20.v20161216.jar;%STUDIO_HOME%\lib\websocket-common-9.2.20.v20161216.jar;%STUDIO_HOME%\lib\websocket-client-9.2.20.v20161216.jar;%STUDIO_HOME%\lib\websocket-servlet-9.2.20.v20161216.jar;%STUDIO_HOME%\lib\picocontainer-2.15.jar;%STUDIO_HOME%\lib\groovy-2.4.4.jar;%STUDIO_HOME%\lib\groovy-templates-2.4.4.jar;%STUDIO_HOME%\lib\gradle-tooling-api-3.1.jar;%STUDIO_HOME%\lib\commons-configuration-1.10.jar;%STUDIO_HOME%\lib\commons-collections-3.2.1.jar;%STUDIO_HOME%\lib\commons-codec-1.10.jar;%STUDIO_HOME%\lib\postgresql-9.4.1212.jar;%STUDIO_HOME%\lib\jtds-1.3.1.jar;%STUDIO_HOME%\lib\mssql-jdbc-6.1.0.jre8.jar;%STUDIO_HOME%\lib\hsqldb-2.2.9.jar;%STUDIO_HOME%\lib\diffutils-1.3.0.jar;%STUDIO_HOME%\lib\httpclient-4.5.1.jar;%STUDIO_HOME%\lib\fluent-hc-4.5.1.jar;%STUDIO_HOME%\lib\evo-inflector-1.2.1.jar;%STUDIO_HOME%\lib\org.eclipse.jgit-4.3.0.201604071810-r.jar;%STUDIO_HOME%\lib\pegdown-1.6.0.jar;%STUDIO_HOME%\lib\jsoup-1.8.3.jar;%STUDIO_HOME%\lib\vaadin-shared-7.7.7.cuba.0.jar;%STUDIO_HOME%\lib\atmosphere-runtime-2.2.9.vaadin2.jar;%STUDIO_HOME%\lib\stringtemplate-3.2.jar;%STUDIO_HOME%\lib\jetty-util-9.2.20.v20161216.jar;%STUDIO_HOME%\lib\websocket-api-9.2.20.v20161216.jar;%STUDIO_HOME%\lib\groovy-xml-2.4.4.jar;%STUDIO_HOME%\lib\httpcore-4.4.3.jar;%STUDIO_HOME%\lib\jsch-0.1.53.jar;%STUDIO_HOME%\lib\JavaEWAH-0.7.9.jar;%STUDIO_HOME%\lib\parboiled-java-1.1.7.jar;%STUDIO_HOME%\lib\vaadin-slf4j-jdk14-1.6.1.jar;%STUDIO_HOME%\lib\antlr-2.7.7.jar;%STUDIO_HOME%\lib\parboiled-core-1.1.7.jar;%STUDIO_HOME%\lib\asm-5.0.3.jar;%STUDIO_HOME%\lib\asm-tree-5.0.3.jar;%STUDIO_HOME%\lib\asm-analysis-5.0.3.jar;%STUDIO_HOME%\lib\asm-util-5.0.3.jar;%STUDIO_HOME%\lib\vaadin-sass-compiler-0.9.13.jar;%STUDIO_HOME%\lib\sac-1.3.jar;%STUDIO_HOME%\lib\flute-1.3.0.gg2.jar;%STUDIO_HOME%\lib\commons-logging-1.2.jar;%APP_HOME%\plugins\*;%USERPROFILE%\.haulmont\studio\lib\ojdbc6.jar;%USERPROFILE%\.haulmont\studio\lib\mysql-connector-java.jar

@rem Execute studio
cd /d %~dp0
echo Using Java executable: %JAVA_EXE%
start "CUBA Studio" "%JAVA_EXE%" %DEFAULT_JVM_OPTS% %JAVA_OPTS% %STUDIO_OPTS%  -classpath "%CLASSPATH%" com.haulmont.studio.server.EntryPoint %CMD_LINE_ARGS%

:end
@rem End local scope for the variables with windows NT shell
if "%ERRORLEVEL%"=="0" goto mainEnd

:fail
rem Set variable STUDIO_EXIT_CONSOLE if you need the _script_ return code instead of
rem the _cmd.exe /c_ return code!
if  not "" == "%STUDIO_EXIT_CONSOLE%" exit 1
exit /b 1

:mainEnd
if "%OS%"=="Windows_NT" endlocal

:omega
