<%def capitalizedPluginId = pluginId.capitalize().replaceAll("\\s", "")
%>package ${projectRootPackage}.bpg;

import com.haulmont.studio.backend.plugin.PluginsRepository;
import com.haulmont.studio.backend.pm.BaseProjectsRepo;
import com.haulmont.studio.common.Config;
import com.haulmont.studio.common.model.base.BaseProject;
import com.haulmont.studio.common.model.DbProperties;
import com.haulmont.studio.backend.plugin.ep.AbstractBaseProjectGroupExtension;
import com.haulmont.studio.backend.maven.MavenRepository;
import com.haulmont.studio.common.model.Module;
import java.util.List;
import java.util.Arrays;

public class ${capitalizedPluginId}BaseProjectGroupExtension extends AbstractBaseProjectGroupExtension {

    public ${capitalizedPluginId}BaseProjectGroupExtension(BaseProjectsRepo baseProjectsRepo, PluginsRepository pluginsRepository,
                                        Config config, MavenRepository mavenRepository) {
        super(baseProjectsRepo, pluginsRepository, config, mavenRepository);
    }

    @Override
    protected String getPluginId() {
        return "${pluginId}";
    }

    @Override
    protected String getArtifactGroup() {
        return "${projectRootPackage}";
    }

    @Override
    protected String getArtifactName() {
        return "${projectModulePrefix}-global";
    }

    @Override
    protected String getProjectName() {
        return "${projectName}";
    }

    @Override
    protected BaseProject createProject(List<BaseProject> cubaBaseProjects) {
        return new ${capitalizedPluginId}BaseProject(cubaBaseProjects);
    }

    @Override
    protected List<String> getCubaBaseProjectNames() {
        return Arrays.asList(<%baseProjectsNames.eachWithIndex{bp, i ->
                print "\"$bp\""
                if (i != baseProjectsNames.size() - 1) print ", "
        }%>);
    }

    @Override
    protected DbProperties.Type getDefaultDbmsType() {
        return DbProperties.Type.${projectDbType.name()};
    }

    @Override
    protected List<String> getModuleNames() {
        return Arrays.asList(Module.Core.NAME, Module.Global.NAME, Module.Gui.NAME, Module.Web.NAME<%if (projectIsPortal) {%>, Module.Portal.NAME<%}%><%if (projectIsDesktopClient) {%>, Module.Desktop.NAME<%}%>);
    }
    <%if (projectIsWebToolkit) {%>
    @Override
    protected String getWidgetSet() {
        return "${projectRootPackage}.web.toolkit.ui.AppWidgetSet";
    }<%} else if (baseProjectsNames.contains('charts')) {%>
    @Override
    protected String getWidgetSet() {
        return "com.haulmont.charts.web.toolkit.ui.ChartsWidgetSet";
    }<%}%>

    @Override
    protected String getApplicationClassName() {
        return "${applicationClassName}";
    }
}
