<#import "/spring.ftl" as spring />

<#function msg code>
    <#assign messageBody>\${message("${project_rootPackage}.portal", code)}</#assign>
    <#return messageBody/>
</#function>

<html>
    <head>
        <title>
            Login page
        </title>
        <link rel="shortcut icon" type="image/x-icon" href="<@spring.url "/resources/favicon.ico"/>">
        <link rel="icon" type="image/gif" href="<@spring.url "/resources/favicon.ico"/>">
        <link rel="stylesheet" href="<@spring.url "/resources/css/common.css"/>"/>
    </head>
    <body>
        <h2>\${msg("page.head")}</h2>
        <div class="span6">
            <h3>Login</h3>
            <% if (platform_6_0_7_plus) {%>
            <#if RequestParameters?? && RequestParameters.error??>
            	<p>Invalid username / password</p>
            </#if>
            <%}%>
            <%if (platform_6_0_plus) {%>
            <form id="f" name="f" method="POST" action="<@spring.url "/login"/>"><%} else {%>
            <form id="loginForm" method="POST"><%}%>
                <% if (platform_6_0_7_plus) {%><input type="hidden" name="\${_csrf.parameterName}" value="\${_csrf.token}"/><%}%>
                <div>
                    <div>
                        <label style="width: 80px" for="login">Login</label>
                        <@spring.formInput path="loginUserCommand.login" fieldType="text"/>
                    </div>
                    <div>
                        <label style="width: 80px" for="password">Password</label>
                        <@spring.formInput path="loginUserCommand.password" fieldType="password"/>
                    </div>
                </div>
                <button type="submit">Login</button>
            </form>
        </div>
    </body>
</html>