def type = getFieldType(restParam)

if (type == null) {
    return
}

def fieldBinding = [
        'type'         : type,
        'bindPath'     : bindPrefix + restParam.name,
        'errorBindPath': 'serverErrors.' + restParam.name,
        'label'        : restParam.name,
        'required'     : false,
        'maxLength'    : null
]

if (type == 'enum') {
    fieldBinding['enumItems'] = "[[enumValues('${api.findEnum(restParam.type).fqn}')]]"
}

if (type == 'lookup') {
    def entity = api.findEntity(restParam.type)
    fieldBinding['lookupEntityName'] = entity.name
    fieldBinding['itemsBindPath'] = "entity_${entity.name}Options"
}

return fieldBinding


def getFieldType(restParam) {
    if (api.findEntity(restParam.type) != null) {
        return 'lookup'
    }
    if (api.findEnum(restParam.type) != null) {
        return 'enum'
    }
    return 'text'
}

//def isLookup(attribute) {
//    return (attribute.isClass()
//            && (attribute.hasAnnotation('ManyToOne')
//            || attribute.hasAnnotation('OneToOne')))
//}